-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local curve_adjustor = 7

local function onInit()
    electrics.values['4ws_Mark_2_TMD'] = 0
end

local function updateGFX(dt)
    if not electrics.values['steering_input'] then return end
    local steer = -electrics.values['steering_input']
    local absSteer = math.abs(steer)
	local speed = electrics.values.wheelspeed
	local gear = electrics.values.gear_M
	local brake = electrics.values.brake
	

	if brake == 1 and electrics.values.rpm > 5000 and (gear == 1 or gear == -1) then
		rws = absSteer
	else
		rws = absSteer * (curve_adjustor / (speed + curve_adjustor) + math.sqrt(speed / 400))
	end
	
    rws = rws * fsign(steer) --Use the sign of the steering input to know the sign of rws output

    electrics.values['4ws_Mark_2_TMD'] = rws
end

-- public interface
M.onInit      = onInit
M.onReset     = onInit
M.updateGFX = updateGFX

return M